/*
 * RegExpAccess.cpp
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#include "RegExpAccess.h"
#include "settings/RegExpSettings.h"

namespace dataAccess {

std::string RegExpAccess::access ( const std::string & component ) {
	RegExpSettings::Settings settings = dataAccess::RegExpSettings::fromString ( component );

	if ( settings == RegExpSettings::Settings::ALPHABET )
		return "regexp::Alphabet";

	if ( settings == RegExpSettings::Settings::CONTENT )
		return "regexp::Content";

	throw exception::CommonException ( "Component not available" );
}

} /* namespace dataAccess */
