/*
 * StringSettings.h
 *
 *  Created on: 26. 3. 2014
 *	  Author: Jan Travnicek
 */

#ifndef __STRING_SETTINGS_H__
#define __STRING_SETTINGS_H__

#include "SettingsHelper.h"

namespace dataAccess {

class StringEnum {
public:
	enum class Settings {
		ALPHABET, CONTENT, __MAX__
	};

	static std::string toString ( StringEnum::Settings settings ) {
		switch ( settings ) {
		case StringEnum::Settings::ALPHABET:
			return "alphabet";

		case StringEnum::Settings::CONTENT:
			return "content";

		case StringEnum::Settings::__MAX__:
			throw exception::CommonException ( "Invalid enumeration" );
		}
		throw exception::CommonException ( "Invalid enumeration" );
	}

};

class StringSettings : public StringEnum, public EnumClassHelper < StringEnum > {
};

} /* namespace dataAccess */

#endif /* __STRING_SETTINGS_H__ */
