/*
 * Rename.cpp
 *
 *  Created on: Dec 9, 2013
 *	Author: Jan Travnicek
 */

#include "Rename.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace simplify {

auto RenameDFA = registration::AbstractRegister < Rename, automaton::DFA < DefaultSymbolType, unsigned >, const automaton::DFA < > & > ( Rename::rename );
auto RenameDPDA = registration::AbstractRegister < Rename, automaton::DPDA < DefaultSymbolType, DefaultEpsilonType, unsigned, unsigned >, const automaton::DPDA < > & > ( Rename::rename );
auto RenameSinglePopDPDA = registration::AbstractRegister < Rename, automaton::SinglePopDPDA < DefaultSymbolType, DefaultEpsilonType, unsigned, unsigned >, const automaton::SinglePopDPDA < > & > ( Rename::rename );
auto RenameInputDrivenDPDA = registration::AbstractRegister < Rename, automaton::InputDrivenDPDA < DefaultSymbolType, unsigned, unsigned >, const automaton::InputDrivenDPDA < > & > ( Rename::rename );
auto RenameVisiblyPushdownDPDA = registration::AbstractRegister < Rename, automaton::VisiblyPushdownDPDA < DefaultSymbolType, unsigned, unsigned >, const automaton::VisiblyPushdownDPDA < > & > ( Rename::rename );
auto RenameRealTimeHeightDeterministicDPDA = registration::AbstractRegister < Rename, automaton::RealTimeHeightDeterministicDPDA < DefaultSymbolType, DefaultEpsilonType, unsigned, unsigned >, const automaton::RealTimeHeightDeterministicDPDA < > & > ( Rename::rename );

} /* namespace simplify */

} /* namespace automaton */
