/*
 * RegExpDerivation.cpp
 *
 *  Created on: 19. 1. 2014
 *	  Author: Tomas Pecka
 */

#include "RegExpDerivation.h"
#include <registration/AlgoRegistration.hpp>

namespace regexp {

auto RegExpDerivationFormalRegExpString = registration::AbstractRegister < RegExpDerivation, regexp::FormalRegExp < >, const regexp::FormalRegExp < > &, const string::LinearString < > & > ( RegExpDerivation::derivation );
auto RegExpDerivationUnboundedRegExpString = registration::AbstractRegister < RegExpDerivation, regexp::UnboundedRegExp < >, const regexp::UnboundedRegExp < > &, const string::LinearString < > & > ( RegExpDerivation::derivation );

auto RegExpDerivationFormalRegExpSymbol = registration::AbstractRegister < RegExpDerivation, regexp::FormalRegExp < >, const regexp::FormalRegExp < > &, const DefaultSymbolType & > ( RegExpDerivation::derivation );
auto RegExpDerivationUnboundedRegExpSymbol = registration::AbstractRegister < RegExpDerivation, regexp::UnboundedRegExp < >, const regexp::UnboundedRegExp < > &, const DefaultSymbolType & > ( RegExpDerivation::derivation );

} /* namespace regexp */
