#include "RegExpIntegralTest.h"

#include "regexp/transform/RegExpIntegral.h"

#include <string/string/LinearString.h>
#include <regexp/string/UnboundedRegExp.h>

#include <factory/StringDataFactory.hpp>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( RegExpIntegralTest, "regexp" );
CPPUNIT_TEST_SUITE_REGISTRATION( RegExpIntegralTest );

void RegExpIntegralTest::setUp() {
}

void RegExpIntegralTest::tearDown() {
}

void RegExpIntegralTest::testRegExpIntegral() {
    // https://edux.fit.cvut.cz/oppa/BI-AAG/cviceni/aag-cv04.pdf

    // Exc. 16
    this->ExecSingleTest("0 1 0 + 1 0 1", "1", "1 0 1 0+1 1 0 1");
}

void RegExpIntegralTest::ExecSingleTest(std::string regexp_str, std::string string_str, std::string result) {
    regexp::UnboundedRegExp < > regexp = factory::StringDataFactory::fromString ( regexp_str );
    string::LinearString < > string = factory::StringDataFactory::fromString ( "\"" + string_str + "\"" );

    std::cout << factory::StringDataFactory::toString(regexp::RegExpIntegral::integral(regexp, string)) << " == " << result << std::endl;

    CPPUNIT_ASSERT(factory::StringDataFactory::toString(regexp::RegExpIntegral::integral(regexp, string)) == result);
}
