#include <alib/list>
#include <alib/type_traits>
#include <alib/set>

#include "ObjectTest.h"

#include "object/Object.h"

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION ( ObjectTest, "object" );
CPPUNIT_TEST_SUITE_REGISTRATION ( ObjectTest );

void ObjectTest::setUp ( ) {
}

void ObjectTest::tearDown ( ) {
}

void ObjectTest::testProperties ( ) {
	CPPUNIT_ASSERT ( std::is_nothrow_move_constructible < object::Object >::value );
	CPPUNIT_ASSERT ( std::is_move_constructible < object::Object >::value && std::is_move_assignable < object::Object >::value );

	object::Object tmp1 { object::AnyObject < unsigned > ( 1 ) };
	object::Object tmp2 { object::AnyObject < unsigned > ( 2 ) };

	std::swap ( tmp1, tmp2 );

	CPPUNIT_ASSERT ( tmp1 == object::Object ( object::AnyObject < unsigned > ( 2 ) ) );
	CPPUNIT_ASSERT ( tmp2 == object::Object ( object::AnyObject < unsigned > ( 1 ) ) );

}

void ObjectTest::testConstruction ( ) {
	object::Object tmp1 ( 1 );
	object::Object tmp2 ( ext::variant < int, std::string > ( 1 ) );
	object::Object tmp3 ( ext::variant < int, ext::variant < std::string, int > > ( ext::variant < std::string, int > ( 1 ) ) );

	CPPUNIT_ASSERT ( tmp1 == tmp2 );
	CPPUNIT_ASSERT ( tmp1 == tmp3 );

	object::Object tmp4 = object::Object ( object::AnyObject < ext::set < int > > ( ext::set < int > { } ) );
	object::Object tmp5 ( ext::set < int > { } );
	object::Object tmp6 ( object::AnyObject < ext::set < int > > ( ext::set < int > { } ) );

	std::cout << tmp6 << std::endl;

	CPPUNIT_ASSERT ( tmp4 == tmp5 );
	CPPUNIT_ASSERT ( tmp4 == tmp6 );

	tmp6 ++;
	object::Object tmp7 ( object::AnyObject < ext::set < int > > ( ext::set < int > { }, 1 ) );

	CPPUNIT_ASSERT ( tmp6 == tmp7 );

	object::Object test = object::Object ( object::AnyObject < object::Object > ( object::Object ( object::AnyObject < ext::set < int > > ( ext::set < int > { } ) ) ) );

	std::cout << test << std::endl;
	std::cout << tmp4 << std::endl;

	CPPUNIT_ASSERT ( test == tmp4 );
}
