/*
 * WildcardLinearString.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "WildcardLinearString.h"

#include <registration/ValuePrinterRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/ComponentRegistration.hpp>

namespace {

static auto components = registration::ComponentRegister < string::WildcardLinearString < > > ( );

static auto WildcardLinearStringFromString = registration::CastRegister < string::WildcardLinearString < char >, std::string > ( );
static auto WildcardLinearStringFromEpsilon = registration::CastRegister < string::WildcardLinearString < >, string::Epsilon < > > ( );
static auto WildcardLinearStringFromLinearString = registration::CastRegister < string::WildcardLinearString < >, string::LinearString < > > ( );

static auto valuePrinter = registration::ValuePrinterRegister < string::WildcardLinearString < > > ( );

} /* namespace */
