// JPS.cpp
//
//     Created on: 19. 02. 2018
//         Author: Jan Uhlik
//    Modified by:
//
// Copyright (c) 2017 Czech Technical University in Prague | Faculty of Information Technology. All rights reserved.
// Git repository: https://gitlab.fit.cvut.cz/algorithms-library-toolkit/automata-library

#include "JPS.hpp"

#include <registration/AlgoRegistration.hpp>

namespace {

auto JPS = registration::AbstractRegister<shortest_path::JPS,
                                          ext::pair<ext::vector<DefaultSquareGridNodeType>, DefaultWeightType>,
                                          const grid::WeightedSquareGrid8<> &,
                                          const DefaultSquareGridNodeType &,
                                          const DefaultSquareGridNodeType &,
                                          std::function<DefaultWeightType(const DefaultSquareGridNodeType &,
                                                                          const DefaultSquareGridNodeType &)> >(
    shortest_path::JPS::findPathRegistration);

}
