// ShortestPathTest.hpp
//
//     Created on: 21. 01. 2018
//         Author: Jan Uhlik
//    Modified by:
//
// Copyright (c) 2017 Czech Technical University in Prague | Faculty of Information Technology. All rights reserved.
// Git repository: https://gitlab.fit.cvut.cz/algorithms-library-toolkit/automata-library

#ifndef ALIB2_SHORTESTPATHTEST_HPP
#define ALIB2_SHORTESTPATHTEST_HPP

#include <cppunit/TestFixture.h>
#include <cppunit/extensions/HelperMacros.h>

class ShortestPathTest : public CppUnit::TestFixture {
 CPPUNIT_TEST_SUITE(ShortestPathTest);
      CPPUNIT_TEST(testBFSGraph);
    CPPUNIT_TEST(testIDDFSGraph);
      CPPUNIT_TEST(testDijkstraGraph);
      CPPUNIT_TEST(testBFSGrid);
      CPPUNIT_TEST(testDijkstraGrid);
      CPPUNIT_TEST(testAStarGrid);
    CPPUNIT_TEST(testAllNonGridAlgorithm);
    CPPUNIT_TEST(testAllGridAlgorithm);
      CPPUNIT_TEST(testAllGridAlgorithmRandom);
  CPPUNIT_TEST_SUITE_END();

 public:
  void setUp() override;
  void tearDown() override;

  void testBFSGraph();
  void testIDDFSGraph();
  void testDijkstraGraph();

  void testBFSGrid();
  void testDijkstraGrid();
  void testAStarGrid();

  void testAllNonGridAlgorithm();
  void testAllGridAlgorithm();

  void testAllGridAlgorithmRandom();
};

#endif //ALIB2_SHORTESTPATHTEST_HPP
