#include "TypeTraitsTest.h"
#include <alib/type_traits>
#include <alib/set>
#include <alib/pair>
#include <alib/typeinfo>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( TypeTraitsTest, "bits" );
CPPUNIT_TEST_SUITE_REGISTRATION( TypeTraitsTest );

void TypeTraitsTest::setUp() {
}

void TypeTraitsTest::tearDown() {
}

void TypeTraitsTest::testTypeInPack() {
	CPPUNIT_ASSERT( ( ext::is_in< int, double, ext::set<int>, float, char, int, std::string >::value ) == true );
	CPPUNIT_ASSERT( ( ext::is_in< long, double, ext::set<int>, float, char, int, std::string >::value ) == false );

	CPPUNIT_ASSERT( ( ext::is_in< std::pair < int, int >, void, ext::pair < int, int > >::value ) == false );
}

class Foo {
};

class Bar;

void TypeTraitsTest::testTypeNames() {
	CPPUNIT_ASSERT ( ext::to_string < Foo > ( ) == "Foo" );
	CPPUNIT_ASSERT ( ext::to_string < Bar > ( ) == "Bar" );
	CPPUNIT_ASSERT ( ext::to_string < int > ( ) == "int" );
}

bool operator < ( const Foo &, int ) {
	return false;
}

void TypeTraitsTest::testSupports() {
	CPPUNIT_ASSERT ( ext::supports < std::less < > ( int, int ) >::value == true );
	CPPUNIT_ASSERT ( ext::supports < std::less < > ( unsigned, int ) >::value == true );
	CPPUNIT_ASSERT ( ext::supports < std::less < > ( double, char ) >::value == true );
	CPPUNIT_ASSERT ( ext::supports < std::less < > ( Foo, char ) >::value == true );
	CPPUNIT_ASSERT ( ext::supports < std::less < > ( Foo, Foo ) >::value == false );
}
