#include <alib/list>
#include "RegExpTest.h"

#include "sax/SaxParseInterface.h"
#include "sax/SaxComposeInterface.h"

#include "regexp/string/UnboundedRegExp.h"
#include "regexp/string/FormalRegExp.h"

#include "factory/StringDataFactory.hpp"

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( RegExpTest, "regexp" );
CPPUNIT_TEST_SUITE_REGISTRATION( RegExpTest );

void RegExpTest::setUp() {
}

void RegExpTest::tearDown() {
}

void RegExpTest::testEqual() {
	{
		std::string input = "#E* #0*";
		regexp::UnboundedRegExp < > regexp = factory::StringDataFactory::fromString (input);

		std::string output = factory::StringDataFactory::toString(regexp);

		CPPUNIT_ASSERT( input == output );

		regexp::UnboundedRegExp < > regexp2 = factory::StringDataFactory::fromString (output);

		CPPUNIT_ASSERT( regexp == regexp2 );
	}
	{
		std::string input = "a+a";
		regexp::FormalRegExp < > regexp = factory::StringDataFactory::fromString (input);

		std::string output = factory::StringDataFactory::toString(regexp);

		CPPUNIT_ASSERT( input == output );

		regexp::FormalRegExp < > regexp2 = factory::StringDataFactory::fromString (output);

		CPPUNIT_ASSERT( regexp == regexp2 );
	}
	{
		std::string input = "a+a (b+a)*";
		regexp::UnboundedRegExp < > regexp = factory::StringDataFactory::fromString (input);

		std::string output = factory::StringDataFactory::toString(regexp);

		CPPUNIT_ASSERT( input == output );
		std::cout << output << std::endl;

		regexp::UnboundedRegExp < > regexp2 = factory::StringDataFactory::fromString (output);

		CPPUNIT_ASSERT( regexp == regexp2 );
	}
}

