#include <alib/typeinfo>

#include <registration/InputFileTypeRegistration.hpp>

#include <registry/StringReaderRegistry.hpp>

#include <abstraction/WrapperAbstraction.hpp>
#include <abstraction/PackingAbstraction.hpp>

namespace {

	std::shared_ptr < abstraction::OperationAbstraction > dummy3 ( const std::string & typehint, const ext::vector < std::string > & ) {
		ext::vector < std::shared_ptr < abstraction::OperationAbstraction > > abstractions;

		ext::vector < std::string > templateParams;
		ext::vector < std::string > paramTypes { ext::to_string < std::string > ( ) };
		abstraction::AlgorithmCategories::AlgorithmCategory category = abstraction::AlgorithmCategories::AlgorithmCategory::NONE;

		abstractions.push_back ( abstraction::Registry::getAlgorithmAbstraction ( "cli::builtin::ReadFile", templateParams, paramTypes, category ) );

		auto stringParserAbstractionFinder = [ = ] ( const std::string & data ) {
			return abstraction::StringReaderRegistry::getAbstraction ( typehint, data );
		};

		abstractions.push_back ( std::make_shared < abstraction::WrapperAbstraction < abstraction::UnspecifiedType, std::string && > > ( stringParserAbstractionFinder ) );

		std::shared_ptr < abstraction::PackingAbstraction < 1 > > res = std::make_shared < abstraction::PackingAbstraction < 1 > > ( std::move ( abstractions ), 1 );
		res->setInnerConnection ( 0, 1, 0, true );
		res->setOuterConnection ( 0, 0, 0 );

		return res;
	}

auto stringInputFileHandler = registration::InputFileRegister ( "string", dummy3 );

}
